diff --git a/src/gui/image/qimage.cpp b/src/gui/image/qimage.cpp
index 8373a55..b5aff87 100644
--- a/src/gui/image/qimage.cpp
+++ b/src/gui/image/qimage.cpp
@@ -265,6 +265,16 @@ bool QImageData::checkForAlphaPixels() const
             end_bits += bytes_per_line;
         }
     } break;
+    case QImage::Format_RGBA64:
+    case QImage::Format_RGBA64_Premultiplied: {
+        uchar *bits = data;
+        for (int y=0; y<height && !has_alpha_pixels; ++y) {
+            for (int x=0; x<width; ++x) {
+                has_alpha_pixels |= !(((QRgba64 *)bits)[x].isOpaque());
+            }
+            bits += bytes_per_line;
+        }
+    } break;
 
     default:
         break;
@@ -1690,6 +1700,10 @@ void QImage::fill(uint pixel)
         qt_rectfill<quint24>(reinterpret_cast<quint24*>(d->data), pixel,
                              0, 0, d->width, d->height, d->bytes_per_line);
         return;
+    } else if (d->depth == 64) {
+        qt_rectfill<quint64>(reinterpret_cast<quint64*>(d->data), QRgba64::fromArgb32(pixel),
+                             0, 0, d->width, d->height, d->bytes_per_line);
+        return;
     }
 
     if (d->format == Format_RGB32)
@@ -1968,6 +1982,26 @@ QImage::Format QImage::format() const
     \sa {Image Formats}
 */
 
+static bool highColorPrecision(QImage::Format format)
+{
+    // Formats with higher color precision than ARGB32_Premultiplied.
+    switch (format) {
+    case QImage::Format_ARGB32:
+    case QImage::Format_RGBA8888:
+    case QImage::Format_BGR30:
+    case QImage::Format_RGB30:
+    case QImage::Format_A2BGR30_Premultiplied:
+    case QImage::Format_A2RGB30_Premultiplied:
+    case QImage::Format_RGBX64:
+    case QImage::Format_RGBA64:
+    case QImage::Format_RGBA64_Premultiplied:
+        return true;
+    default:
+        break;
+    }
+    return false;
+}
+
 /*!
     \internal
 */
@@ -1980,8 +2014,18 @@ QImage QImage::convertToFormat_helper(Format format, Qt::ImageConversionFlags fl
         return QImage();
 
     Image_Converter converter = qimage_converter_map[d->format][format];
-    if (!converter && format > QImage::Format_Indexed8 && d->format > QImage::Format_Indexed8)
-        converter = convert_generic;
+    if (!converter && format > QImage::Format_Indexed8 && d->format > QImage::Format_Indexed8) {
+        if (highColorPrecision(format) && highColorPrecision(d->format)) {
+            // Convert over RGBA64_Premultiplied
+            if (format == QImage::Format_RGBA64_Premultiplied)
+                converter = convert_generic_to_rgb64;
+            else {
+                Q_ASSERT(d->format != QImage::Format_RGBA64_Premultiplied);
+                return convertToFormat(Format_RGBA64_Premultiplied, flags).convertToFormat(format, flags);
+            }
+        } else
+            converter = convert_generic;
+    }
     if (converter) {
         QImage image(d->width, d->height, format);
 
@@ -4346,6 +4390,9 @@ int QImage::bitPlaneCount() const
     case QImage::Format_RGB444:
         bpc = 12;
         break;
+    case QImage::Format_RGBX64:
+        bpc = 48;
+        break;
     default:
         bpc = qt_depthForFormat(d->format);
         break;
@@ -4422,6 +4469,14 @@ static QImage rotated90(const QImage &image) {
                         reinterpret_cast<quint8*>(out.bits()),
                         out.bytesPerLine());
         break;
+    case QImage::Format_RGBX64:
+    case QImage::Format_RGBA64:
+    case QImage::Format_RGBA64_Premultiplied:
+        qt_memrotate270(reinterpret_cast<const quint64*>(image.bits()),
+                        w, h, image.bytesPerLine(),
+                        reinterpret_cast<quint64*>(out.bits()),
+                        out.bytesPerLine());
+        break;
     default:
         for (int y=0; y<h; ++y) {
             if (image.colorCount())
@@ -4490,6 +4545,14 @@ static QImage rotated270(const QImage &image) {
                        reinterpret_cast<quint8*>(out.bits()),
                        out.bytesPerLine());
         break;
+    case QImage::Format_RGBX64:
+    case QImage::Format_RGBA64:
+    case QImage::Format_RGBA64_Premultiplied:
+        qt_memrotate90(reinterpret_cast<const quint64*>(image.bits()),
+                       w, h, image.bytesPerLine(),
+                       reinterpret_cast<quint64*>(out.bits()),
+                       out.bytesPerLine());
+        break;
     default:
         for (int y=0; y<h; ++y) {
             if (image.colorCount())
@@ -4615,6 +4678,9 @@ QImage QImage::transformed(const QTransform &matrix, Qt::TransformationMode mode
             case QImage::Format_RGB30:
                 target_format = Format_A2RGB30_Premultiplied;
                 break;
+            case QImage::Format_RGBX64:
+                target_format = Format_RGBA64_Premultiplied;
+                break;
             default:
                 target_format = Format_ARGB32_Premultiplied;
                 break;
@@ -5117,6 +5183,45 @@ static Q_CONSTEXPR QPixelFormat pixelformats[] = {
                     /*PREMULTIPLIED*/     QPixelFormat::NotPremultiplied,
                     /*INTERPRETATION*/    QPixelFormat::UnsignedByte,
                     /*BYTE ORDER*/        QPixelFormat::CurrentSystemEndian),
+        //QImage::Format_RGBX64:
+        QPixelFormat(QPixelFormat::RGB,
+                     /*RED*/                16,
+                     /*GREEN*/              16,
+                     /*BLUE*/               16,
+                     /*FOURTH*/             0,
+                     /*FIFTH*/              0,
+                     /*ALPHA*/              16,
+                     /*ALPHA USAGE*/       QPixelFormat::IgnoresAlpha,
+                     /*ALPHA POSITION*/    QPixelFormat::AtEnd,
+                     /*PREMULTIPLIED*/     QPixelFormat::NotPremultiplied,
+                     /*INTERPRETATION*/    QPixelFormat::UnsignedShort,
+                     /*BYTE ORDER*/        QPixelFormat::CurrentSystemEndian),
+        //QImage::Format_RGBA64:
+        QPixelFormat(QPixelFormat::RGB,
+                     /*RED*/                16,
+                     /*GREEN*/              16,
+                     /*BLUE*/               16,
+                     /*FOURTH*/             0,
+                     /*FIFTH*/              0,
+                     /*ALPHA*/              16,
+                     /*ALPHA USAGE*/       QPixelFormat::UsesAlpha,
+                     /*ALPHA POSITION*/    QPixelFormat::AtEnd,
+                     /*PREMULTIPLIED*/     QPixelFormat::Premultiplied,
+                     /*INTERPRETATION*/    QPixelFormat::UnsignedShort,
+                     /*BYTE ORDER*/        QPixelFormat::CurrentSystemEndian),
+         //QImage::Format_RGBA64_Premultiplied:
+         QPixelFormat(QPixelFormat::RGB,
+                     /*RED*/                16,
+                     /*GREEN*/              16,
+                     /*BLUE*/               16,
+                     /*FOURTH*/             0,
+                     /*FIFTH*/              0,
+                     /*ALPHA*/              16,
+                     /*ALPHA USAGE*/       QPixelFormat::UsesAlpha,
+                     /*ALPHA POSITION*/    QPixelFormat::AtEnd,
+                     /*PREMULTIPLIED*/     QPixelFormat::Premultiplied,
+                     /*INTERPRETATION*/    QPixelFormat::UnsignedShort,
+                     /*BYTE ORDER*/        QPixelFormat::CurrentSystemEndian),
 };
 Q_STATIC_ASSERT(sizeof(pixelformats) / sizeof(*pixelformats) == QImage::NImageFormats);
 
diff --git a/src/gui/image/qimage.h b/src/gui/image/qimage.h
index 7751bbe..953bf60 100644
--- a/src/gui/image/qimage.h
+++ b/src/gui/image/qimage.h
@@ -113,6 +113,9 @@ public:
         Format_A2RGB30_Premultiplied,
         Format_Alpha8,
         Format_Grayscale8,
+        Format_RGBX64,
+        Format_RGBA64,
+        Format_RGBA64_Premultiplied,
 #if 0
         // reserved for future use
         Format_Grayscale16,
